m4_include([m4/search-libs.m4])

AC_DEFUN([AM_PATH_BDB],[
AC_ARG_WITH(bdb4,
[  --with-bdb4             use Berkeley DB 4],[
    WITH_BDB4="${withval}"
],[WITH_BDB4="no"])

BDB_CPP_ERROR="You must define CPPFLAGS with '-I<directory>'."
BDB_LD_ERROR="You must define LIBS with '-L<directory> -l<name>'."
case $WITH_BDB4 in
yes)
    for h in db.h db_185.h ; do
        AC_CHECK_HEADER([$h], [], [
        AC_MSG_ERROR(["$h" is not found. $BDB_CPP_ERROR])
        ])
    done

    AC_MSG_CHECKING([db.h is part of version 4])
    AC_PREPROC_IFELSE([AC_LANG_PROGRAM([
#include <db.h>
    ],[
#if !defined(DB_VERSION_MAJOR) || DB_VERSION_MAJOR != 4
#error Berkeley DB: version mismatch
#endif
    ])], [], [
        AC_MSG_RESULT([no])
        AC_MSG_ERROR(["db.h" is not part of version 4. $BDB_CPP_ERROR])
    ])
    AC_MSG_RESULT([yes])

    f="db_create"
    AM_SEARCH_LIBS_IFELSE([AC_LANG_PROGRAM([
#include <db.h>
    ],[
int s = $f(0, 0, 0);
    ])], [$f], [db], [], [
        AC_MSG_ERROR([failed to link the function '$f()'. $BDB_LD_ERROR])
    ])

    AC_MSG_CHECKING([dbopen() (compat185)])
    AC_LINK_IFELSE([AC_LANG_PROGRAM([
#include <db_185.h>
    ],[
DB *db = dbopen(0, 0, 0, DB_BTREE, 0);
    ])], [], [
        AC_MSG_RESULT([no])
        AC_MSG_ERROR([$BDB_LD_ERROR])
    ])
    CPPFLAGS="${CPPFLAGS} -DWITH_BDB4"
    AC_MSG_RESULT([yes])
    ;;
*)
    h="db.h"
    AC_CHECK_HEADER([$h], [], [
        AC_MSG_ERROR(["$h" is not found. $BDB_CPP_ERROR])
    ])

    AC_MSG_CHECKING([db.h is part of version 1.85])
    AC_PREPROC_IFELSE([AC_LANG_PROGRAM([
#include <db.h>
    ],[
#ifdef DB_VERSION_MAJOR
#error Berkeley DB: version mismatch
#endif
    ])], [], [
        AC_MSG_RESULT([no])
        AC_MSG_ERROR(["$h" is not part of version 1.85. $BDB_CPP_ERROR  Or, try to specify "--with-bdb4".])
    ])
    AC_MSG_RESULT([yes])

    f="dbopen"
    AC_SEARCH_LIBS([$f], [db db1], [], [
        AC_MSG_ERROR([failed to link the function '$f()'. $BDB_LD_ERROR])
    ])

    AC_MSG_CHECKING([dbopen()])
    AC_LINK_IFELSE([AC_LANG_PROGRAM([
#include <db.h>
    ],[
DB *db = dbopen(0, 0, 0, DB_BTREE, 0);
    ])], [], [
        AC_MSG_RESULT([no])
        AC_MSG_ERROR([$BDB_LD_ERROR])
    ])
    AC_MSG_RESULT([yes])
    ;;
esac
])
