#define std_lang_Object_IMPORT
#define std_io_File_IMPORT
#define std_io_FileDescriptor_IMPORT
#define std_io_InputTube_IMPORT

#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <std/io/impl/File.h>
#include <std/io/FileDescriptor.h>
#include <std/io/InputTube.h>

union File
File_create(const char *path)
{
    struct impl_File *impl;

    if ((impl = malloc(sizeof(*impl))) == NULL) {
        return (union File)Object_NULL;
    }
    impl->path = NULL;

    if ((impl->path = strdup(path)) == NULL) {
	File_free((union File)impl);
        return (union File)Object_NULL;
    }
    return (union File)impl;
}

void
File_free(union File file)
{
    struct impl_File *impl = file.impl;

    if (impl == NULL)
	return;
    free(impl->path);
    free(impl);
}

union InputTube
File_createInputTube(union File file)
{
    struct impl_File *impl = file.impl;
    union InputTube in;
    int fd;

    if ((fd = open(impl->path, O_RDONLY)) < 0) {
	return (union InputTube)Object_NULL;
    }
    if ((in = FileDescriptor_createInputTube(fd, FileDescriptor_AUTO)).impl
	== NULL) {
	close(fd);
	return (union InputTube)Object_NULL;
    }
    return in;
}
